diff -ruN qmail-1.03-orig/POPBEFORESMTP qmail-1.03-ldap-20060201-orig/POPBEFORESMTP
--- qmail-1.03-orig/POPBEFORESMTP	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/POPBEFORESMTP	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,194 @@
+POPBEFORESMTP by Claudio Jeker <jeker@n-r-g.com> and 
+Andre Oppermann <opi@nrg4u.com>
+(c) 2002-2004 Internet Business Solutions Ltd.
+
+The POPBEFORESMTP tools are a part of the qmail-ldap patch.
+This patch for qmail comes with NO WARRANTY.
+
+RELEASE: current ($Date: 2004/04/16 13:24:16 $)
+
+POP-Before-SMTP:
+======================
+
+TOC:
+ HOW DOES IT WORK
+ INSTALL
+ CONFIG FILES
+ SETUP
+  - pbsadd
+  - pbscheck
+  - pbsdbd
+ EXAMPLES
+
+================================================================================
+
+HOW DOES IT WORK
+
+ From http://www.lifewithqmail.org/ldap:
+    As we all know, SMTP does not contain any authentication mechanisms by
+    default. So in practice you are allowing relaying through your server only
+    for some IP addresses, normally your corporate network. If your users are
+    coming from various, dynamic IP addresses they can't use your mailserver
+    for sending :-((
+    
+    To overcome this limitation there are 3 possibilities:
+    
+    -  relaying based on the envelope sender - a really bad idea, easy to abuse.
+    -  SMTP AUTH - great, but your clients need to support it. For a patch see
+       http://www.lifewithqmail.org/ldap
+    -  POP-before-SMTP - when the user gets his mail through pop3 or imap, his
+       IP address is recorded and the permission to relay is given for this IP
+       for a defined time.
+    
+    SMTP AUTH would be the best solution as username and password are supplied
+    when sending, but as long as too many clients are lacking support for it,
+    this is not an option for most of us.
+    
+ Most POP-before-SMTP solutions use the tcpserver tcprules cdb file to
+ store the allowed IP addresses. This does not work in a clustered setup.
+ Our solution uses two clients pbsadd and pbscheck and a server pbsdbd which 
+ stores the IP addresses in a database.
+ pbsadd has to be added just after auth_pop or auth_imap and will add new
+ allowed IP addresses to the cache.
+ pbscheck runs before qmail-smtpd and sets the RELAYCLIENT environment if the
+ IP address is allowed to relay.
+ pbsdbd is the Pop-Before-Smtp DataBase Daemon. pbsdbd uses a similar cache 
+ algorithm as djbdns' dnscache daemon.
+ pbsadd and pbscheck communicate over UDP with the pbsdbd server.
+ 
+================================================================================
+
+INSTALL
+
+ The Tools pbsadd, pbscheck and pbsdbd are installed in the qmail binary
+ directory, normally /var/qmail/bin.
+ 
+ NOTE: the tools can also be used on qmail systems without the qmail-ldap patch.
+ 
+================================================================================
+
+CONFIG FILES
+
+~control/pbsservers
+ 
+ A list of IP addresses of running pbsdbd servers.
+ This file is only used by the clients pbsadd and pbscheck.
+ Required
+ Example:
+   127.0.0.1
+   10.0.1.1
+   10.0.2.1
+ 
+~control/pbsip
+ 
+ The pbsdbd server's address is given through this control file.
+ This file is only needed for the pbsdbd server.
+ Default: 0.0.0.0
+ Example: 127.0.0.1
+ 
+~control/pbsport
+
+ The port where all pbsdbd servers are listening on.
+ This file if used is needed by all pbs tools and has to be in sync on all
+ cluster machines. 
+ Default: 2821
+ Example: 6666
+ Note: Ports > 1024 should be used so that the pbsdbd server can be run
+       unprivileged.
+ 
+~control/pbssecret
+
+ Shared secret used by pbsadd and pbsdbd to authenticate the client.
+ Required for pbsdbd and pbsadd.
+ Example: mekmitasdigoat
+ 
+~control/pbscachesize
+
+ Size in bytes used for the cache. Normally you do not need to set this
+ because the default value is big enough.
+ Default: 1048576 /* equal to 1 MB */
+
+~control/pbstimeout
+ 
+ Timeout in seconds until entries in the cache are invalidated.
+ Only used by the pbsdbd server.
+ Default: 600
+ Example: 900
+ 
+~control/pbsenv
+
+ Additional environment variables to include.
+ pbscheck will set these variables to the values pbsadd returned.
+ It is possible to rewrite the variables. A line like
+ USER=TCPREMOTEINFO will cause pbscheck to set the environment TCPREMOTEINFO
+ to the value set as USER in pbsadd. If you like to prepend some identifier
+ in front of the value you can this like this:
+ USER=TCPREMOTEINFO=[pbs]   this will add [pbs] in front of the value returned
+ by pbsadd.
+ Multiline.
+ Default: none
+ Example: HOST
+          TCPREMOTEIP=FROMIP
+          USER=TCPREMOTEINFO=[pbs]
+          
+
+================================================================================
+
+SETUP
+
+pbsadd:
+  usage: pbsadd subprogram ...
+  
+  pbsadd will try to add the IP address $TCPREMOTEIP to all pbsdbd servers
+  listed in ~control/pbsservers. Afterward the subprogram with its arguments
+  is started.
+  On non fatal errors the subprogram will be started without successfully 
+  update the database on the pbsdbd servers.
+  
+pbscheck:
+  usage: pbscheck subprogram ...
+  
+  pbscheck checks if the IP address $TCPREMOTEIP is allowed to relay.
+  It will send queries to the pbsdbd servers listed in ~control/pbsservers.
+  The first query will be sent to a randomly chosen server, if this timeouts
+  all servers will be tried one after another.
+  If the IP is allowed to relay the environment $RELAYCLIENT is set.
+  On non fatal errors the subprogram will be started without setting
+  $RELAYCLIENT.
+  
+pbsdbd:
+  usage: pbsdbd
+  
+  pbsdbd will listen on address specified in ~control/pbsip and the port 
+  specified in ~control/pbsport (default 2821).
+  IP addresses will only be added to the cache if the secret specified in
+  ~control/pbssecret is included in the add request.
+
+================================================================================
+
+EXAMPLES
+
+ First create all necessary ~control files.
+ 
+ NOTE: the following shell scripts are not finished. You have to edit them to
+ modify them for your needs.
+ 
+ The pbsdbd should be run as unprivileged user, this can be done with setuidgid.
+ 
+ #!/bin/sh
+ setuidgid qmaild pbsdbd
+ 
+ pbsadd has to be run after auth_pop, auth_imap or checkpassword in the pop3 or
+ imap tool chain.
+ 
+ #!/bin/sh
+ tcpserver 0 110 qmail-popup $HOST auth_pop pbsadd qmail-pop3d ./Maildir/
+ 
+ 
+ pbscheck has to be run before qmail-smtpd.
+ 
+ #!/bin/sh
+ tcpserver -x $SMTPRULES -v -u qmaild -g nofiles 0 25 pbscheck qmail-smtpd
+ 
+
+END :-)
diff -ruN qmail-1.03-orig/popfetch.pl qmail-1.03-ldap-20060201-orig/popfetch.pl
--- qmail-1.03-orig/popfetch.pl	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/popfetch.pl	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,94 @@
+#!/usr/bin/perl
+#
+# Copyright (c) 1999-2004 Andre Oppermann,
+#      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+# 3. All advertising materials mentioning features or use of this software
+#    must display the following acknowledgement:
+#      This product includes software developed by Internet Business
+#      Solutions AG and its contributors.
+# 4. Neither the name of the author nor the names of its contributors
+#    may be used to endorse or promote products derived from this software
+#    without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+# $localhost and $server need to changed
+# If a file by the name "done" exists in the maildir we don't try to
+# fetch the mails again.
+# by Ingo Oppermann
+
+use Mail::POP3Client;
+
+# Variables
+
+$path       = $ARGV[3];
+$mailpath   = "./".$path;
+$username   = $ARGV[0];
+$pw         = $ARGV[1];
+$server     = 'mail.pipeline.ch';
+$localhost  = "mail.schweizerinserate.ch";
+@filenames;
+
+# Main
+
+if(-e $mailpath."/done")
+{
+        ;
+}
+else
+{
+        $pop = new Mail::POP3Client($username,$pw,$server);
+        $numofmails = $pop->Count;
+        print $numofmails;
+        for($i = 1; $i <= $numofmails; $i++)
+        {
+                $curtime = time();
+                $random = rand();
+                $filename = $curtime.".".$$.".".$random.$localhost;
+                push(@filenames, $filename);
+                open(OUT, ">".$mailpath."/tmp/".$filename);
+                foreach($pop->Retrieve($i))
+                {
+                        print OUT $_, "\n";
+                }
+# Uncomment the next line if the retrieved mail should be deleted from
+# the old pop server
+        #       $pop->Delete($i);
+                close(OUT);
+        }
+        $pop->Close;
+
+        foreach(@filenames)
+        {
+                $filename = $_;
+                $program = "mv $mailpath/tmp/$filename $mailpath/new/$filename";
+                open(PROG, "|$program");
+                close(PROG);
+        }
+        open(CHECK, ">$mailpath/done");
+        print CHECK 1;
+        close(CHECK);
+}
+
+exec "$ARGV[2] $ARGV[3]";
+
diff -ruN qmail-1.03-orig/predate.c qmail-1.03-ldap-20060201-orig/predate.c
--- qmail-1.03-orig/predate.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/predate.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <time.h>
+#include <unistd.h>
 #include "datetime.h"
 #include "fork.h"
 #include "wait.h"
@@ -10,17 +11,18 @@
 #include "subfd.h"
 #include "readwrite.h"
 #include "exit.h"
+#include "sig.h"
 
 #define FATAL "predate: fatal: "
 
-static char *montab[12] = {
+static const char *montab[12] = {
 "Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"
 };
 
 char num[FMT_ULONG];
 char outbuf[1024];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -29,7 +31,7 @@
   struct datetime dt;
   datetime_sec utc;
   datetime_sec local;
-  int minutes;
+  unsigned int minutes;
   int pi[2];
   substdio ss;
   int wstat;
@@ -55,7 +57,7 @@
       strerr_die4sys(111,FATAL,"unable to run ",argv[1],": ");
   }
   close(pi[0]);
-  substdio_fdbuf(&ss,write,pi[1],outbuf,sizeof(outbuf));
+  substdio_fdbuf(&ss,subwrite,pi[1],outbuf,sizeof(outbuf));
 
   time(&now);
 
@@ -112,5 +114,5 @@
     strerr_die2sys(111,FATAL,"wait failed: ");
   if (wait_crashed(wstat))
     strerr_die2x(111,FATAL,"child crashed");
-  _exit(wait_exitcode(wstat));
+  return wait_exitcode(wstat);
 }
diff -ruN qmail-1.03-orig/preline.c qmail-1.03-ldap-20060201-orig/preline.c
--- qmail-1.03-orig/preline.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/preline.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "fd.h"
 #include "sgetopt.h"
 #include "readwrite.h"
@@ -23,10 +24,10 @@
 
 char outbuf[SUBSTDIO_OUTSIZE];
 char inbuf[SUBSTDIO_INSIZE];
-substdio ssout = SUBSTDIO_FDBUF(write,1,outbuf,sizeof outbuf);
-substdio ssin = SUBSTDIO_FDBUF(read,0,inbuf,sizeof inbuf);
+substdio ssout = SUBSTDIO_FDBUF(subwrite,1,outbuf,sizeof outbuf);
+substdio ssin = SUBSTDIO_FDBUF(subread,0,inbuf,sizeof inbuf);
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -86,5 +87,5 @@
     strerr_die2sys(111,FATAL,"wait failed: ");
   if (wait_crashed(wstat))
     strerr_die2x(111,FATAL,"child crashed");
-  _exit(wait_exitcode(wstat));
+  return wait_exitcode(wstat);
 }
diff -ruN qmail-1.03-orig/prioq.c qmail-1.03-ldap-20060201-orig/prioq.c
--- qmail-1.03-orig/prioq.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/prioq.c	2006-02-25 11:00:55.000000000 +0100
@@ -36,9 +36,9 @@
 void prioq_delmin(pq)
 prioq *pq;
 {
- int i;
- int j;
- int n;
+ unsigned int i;
+ unsigned int j;
+ unsigned int n;
  if (!pq->p) return;
  n = pq->len;
  if (!n) return;
diff -ruN qmail-1.03-orig/prioq.h qmail-1.03-ldap-20060201-orig/prioq.h
--- qmail-1.03-orig/prioq.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/prioq.h	2006-02-25 11:00:55.000000000 +0100
@@ -8,8 +8,8 @@
 
 GEN_ALLOC_typedef(prioq,struct prioq_elt,p,len,a)
 
-extern int prioq_insert();
-extern int prioq_min();
-extern void prioq_delmin();
+extern int prioq_insert(prioq *, struct prioq_elt *);
+extern int prioq_min(prioq *, struct prioq_elt *);
+extern void prioq_delmin(prioq *);
 
 #endif
diff -ruN qmail-1.03-orig/prot.c qmail-1.03-ldap-20060201-orig/prot.c
--- qmail-1.03-orig/prot.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/prot.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,9 +1,10 @@
+#include <unistd.h>
 #include "hasshsgr.h"
 #include "prot.h"
 
 /* XXX: there are more portability problems here waiting to leap out at me */
 
-int prot_gid(gid) int gid;
+int prot_gid(gid) unsigned int gid;
 {
 #ifdef HASSHORTSETGROUPS
   short x[2];
@@ -15,7 +16,7 @@
   return setgid(gid); /* _should_ be redundant, but on some systems it isn't */
 }
 
-int prot_uid(uid) int uid;
+int prot_uid(uid) unsigned int uid;
 {
   return setuid(uid);
 }
diff -ruN qmail-1.03-orig/prot.h qmail-1.03-ldap-20060201-orig/prot.h
--- qmail-1.03-orig/prot.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/prot.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,7 @@
 #ifndef PROT_H
 #define PROT_H
 
-extern int prot_gid();
-extern int prot_uid();
+extern int prot_gid(unsigned int);
+extern int prot_uid(unsigned int);
 
 #endif
diff -ruN qmail-1.03-orig/qbiff.c qmail-1.03-ldap-20060201-orig/qbiff.c
--- qmail-1.03-orig/qbiff.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qbiff.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include <utmp.h>
 #ifndef UTMP_FILE
 #ifdef _PATH_UTMP
@@ -33,7 +34,7 @@
 stralloc tofrom = {0};
 stralloc text = {0};
 
-void doit(s,n) char *s; int n;
+void doit(s,n) char *s; unsigned int n;
 {
  if (!stralloc_catb(&text,s,n)) _exit(0);
  if (text.len > 78) text.len = 78;
@@ -41,7 +42,7 @@
 void dobody(h) stralloc *h; { doit(h->s,h->len); }
 void doheader(h) stralloc *h;
 {
- int i;
+ unsigned int i;
  if (hfield_known(h->s,h->len) == H_SUBJECT)
   {
    i = hfield_skipname(h->s,h->len);
@@ -50,13 +51,13 @@
 }
 void finishheader() { ; }
 
-void main()
+int main()
 {
  char *user;
  char *sender;
  char *userext;
  struct stat st;
- int i;
+ unsigned int i;
 
  if (chdir("/dev") == -1) _exit(0);
 
@@ -90,9 +91,9 @@
 
  fdutmp = open_read(UTMP_FILE);
  if (fdutmp == -1) _exit(0);
- substdio_fdbuf(&ssutmp,read,fdutmp,bufutmp,sizeof(bufutmp));
+ substdio_fdbuf(&ssutmp,subread,fdutmp,bufutmp,sizeof(bufutmp));
 
- while (substdio_get(&ssutmp,&ut,sizeof(ut)) == sizeof(ut))
+ while (substdio_get(&ssutmp,(char *)&ut,sizeof(ut)) == sizeof(ut))
    if (!str_diffn(ut.ut_name,user,sizeof(ut.ut_name)))
     {
      byte_copy(line,sizeof(ut.ut_line),ut.ut_line);
@@ -105,9 +106,9 @@
      if (fstat(fdtty,&st) == -1) { close(fdtty); continue; }
      if (!(st.st_mode & 0100)) { close(fdtty); continue; }
      if (st.st_uid != getuid()) { close(fdtty); continue; }
-     substdio_fdbuf(&sstty,write,fdtty,buftty,sizeof(buftty));
+     substdio_fdbuf(&sstty,subwrite,fdtty,buftty,sizeof(buftty));
      substdio_putflush(&sstty,woof.s,woof.len);
      close(fdtty);
     }
- _exit(0);
+ return 0;
 }
